diff --git a/sys/dev/netif/re/re.c b/sys/dev/netif/re/re.c
index dfe6b3a706..16958e8335 100644
--- a/sys/dev/netif/re/re.c
+++ b/sys/dev/netif/re/re.c
@@ -2245,20 +3042,19 @@ static void re_hw_mac_mcu_config(struct re_softc *sc)
 #define ISRIMR_DASH_TYPE2_TX_DISABLE_IDLE BIT_5
 static void Dash2DisableTx(struct re_softc *sc)
 {
-        //if (!re_check_dash(sc)) return;
+        //if (!sc->re_dash) return;
 
-        if (sc->re_type == MACFG_61 || sc->re_type == MACFG_62 ||
-            sc->re_type == MACFG_67) {
+        if (HW_DASH_SUPPORT_TYPE_2(sc) || HW_DASH_SUPPORT_TYPE_3(sc)) {
                 u_int16_t WaitCnt;
                 u_int8_t TmpUchar;
 
                 //Disable oob Tx
-                CSR_WRITE_1(sc, RE_IBCR2, CSR_READ_1(sc, RE_IBCR2) & ~(BIT_0));
+                RE_CMAC_WRITE_1(sc, RE_CMAC_IBCR2, RE_CMAC_READ_1(sc, RE_CMAC_IBCR2) & ~(BIT_0));
                 WaitCnt = 0;
 
                 //wait oob tx disable
                 do {
-                        TmpUchar = CSR_READ_1(sc, RE_IBISR0);
+                        TmpUchar = RE_CMAC_READ_1(sc, RE_CMAC_IBISR0);
 
                         if (TmpUchar & ISRIMR_DASH_TYPE2_TX_DISABLE_IDLE) {
                                 break;
@@ -2269,28 +3065,67 @@ static void Dash2DisableTx(struct re_softc *sc)
                 } while(WaitCnt < 2000);
 
                 //Clear ISRIMR_DASH_TYPE2_TX_DISABLE_IDLE
-                CSR_WRITE_1(sc, RE_IBISR0, CSR_READ_1(sc, RE_IBISR0) | ISRIMR_DASH_TYPE2_TX_DISABLE_IDLE);
+                RE_CMAC_WRITE_1(sc, RE_CMAC_IBISR0, RE_CMAC_READ_1(sc, RE_CMAC_IBISR0) | ISRIMR_DASH_TYPE2_TX_DISABLE_IDLE);
         }
 }
 
 static void Dash2DisableRx(struct re_softc *sc)
 {
-        //if (!re_check_dash(sc)) return;
+        //if (!sc->re_dash) return;
 
-        if (sc->re_type == MACFG_61 || sc->re_type == MACFG_62 ||
-            sc->re_type == MACFG_67)
-                CSR_WRITE_1(sc, RE_IBCR0, CSR_READ_1(sc, RE_IBCR0) & ~(BIT_0));
+        if (HW_DASH_SUPPORT_TYPE_2(sc) || HW_DASH_SUPPORT_TYPE_3(sc)) {
+                RE_CMAC_WRITE_1(sc, RE_CMAC_IBCR0, RE_CMAC_READ_1(sc, RE_CMAC_IBCR0) & ~(BIT_0));
+        }
 }
 
 static void Dash2DisableTxRx(struct re_softc *sc)
 {
-        if (sc->re_type == MACFG_61 || sc->re_type == MACFG_62 ||
-            sc->re_type == MACFG_67) {
+        if (HW_DASH_SUPPORT_TYPE_2(sc) || HW_DASH_SUPPORT_TYPE_3(sc)) {
                 Dash2DisableTx(sc);
                 Dash2DisableRx(sc);
         }
 }
 
+static inline bool
+is_zero_ether_addr(const u_int8_t * addr)
+{
+        return ((addr[0] + addr[1] + addr[2] + addr[3] + addr[4] + addr[5]) == 0x00);
+}
+
+static inline bool
+is_multicast_ether_addr(const u_int8_t * addr)
+{
+        return (0x01 & addr[0]);
+}
+
+/*
+static inline bool
+is_broadcast_ether_addr(const u_int8_t * addr)
+{
+        return ((addr[0] + addr[1] + addr[2] + addr[3] + addr[4] + addr[5]) == (6 * 0xff));
+}
+*/
+
+static inline bool
+is_valid_ether_addr(const u_int8_t * addr)
+{
+        return !is_multicast_ether_addr(addr) && !is_zero_ether_addr(addr);
+}
+
+static inline void
+random_ether_addr(u_int8_t * dst)
+{
+#ifndef __DragonFly__
+        if (read_random(dst, 6) == 0)
+                arc4rand(dst, 6, 0);
+#else
+	karc4rand(dst, 6);
+#endif
+
+        dst[0] &= 0xfe;
+        dst[0] |= 0x02;
+}
+
 static void re_disable_now_is_oob(struct re_softc *sc)
 {
         if (sc->re_hw_supp_now_is_oob_ver == 1)
@@ -2302,27 +3137,20 @@ static void re_exit_oob(struct re_softc *sc)
         u_int16_t data16;
         int i;
 
-        CSR_WRITE_1(sc, RE_EECMD, RE_EEMODE_OFF);
+        re_disable_cfg9346_write(sc);
 
         switch(sc->re_type) {
         case MACFG_61:
         case MACFG_62:
         case MACFG_67:
+        case MACFG_70:
+        case MACFG_71:
                 Dash2DisableTxRx(sc);
                 break;
         }
 
-        switch(sc->re_type) {
-        case MACFG_61:
-        case MACFG_62:
-        case MACFG_67:
-        case MACFG_63:
-        case MACFG_64:
-        case MACFG_65:
-        case MACFG_66:
+        if (sc->re_dash)
                 re_driver_start(sc);
-                break;
-        }
 
         switch(sc->re_type) {
         case MACFG_56:
@@ -2335,6 +3163,8 @@ static void re_exit_oob(struct re_softc *sc)
         case MACFG_67:
         case MACFG_68:
         case MACFG_69:
+        case MACFG_70:
+        case MACFG_71:
                 CSR_WRITE_1(sc, 0xF2, CSR_READ_1(sc, 0xF2) | BIT_3);
                 DELAY(2000);
 
@@ -2414,6 +3244,8 @@ static void re_exit_oob(struct re_softc *sc)
         case MACFG_67:
         case MACFG_68:
         case MACFG_69:
+        case MACFG_70:
+        case MACFG_71:
                 data16 = MP_ReadMcuAccessRegWord(sc, 0xE8DE) & ~BIT_14;
                 MP_WriteMcuAccessRegWord(sc, 0xE8DE, data16);
                 for (i = 0; i < 10; i++) {
@@ -2437,6 +3269,8 @@ static void re_exit_oob(struct re_softc *sc)
         switch(sc->re_type) {
         case MACFG_68:
         case MACFG_69:
+        case MACFG_70:
+        case MACFG_71:
                 if (re_is_ups_resume(sc)) {
                         re_wait_phy_ups_resume(sc, 2);
                         re_clear_ups_resume_bit(sc);
@@ -2525,11 +3359,14 @@ static void re_hw_init(struct re_softc *sc)
         case MACFG_67:
         case MACFG_68:
         case MACFG_69:
-                CSR_WRITE_1(sc, RE_EECMD, RE_EEMODE_WRITECFG);
+        case MACFG_70:
+        case MACFG_71:
+                re_enable_cfg9346_write(sc);
                 CSR_WRITE_1(sc, RE_CFG5, CSR_READ_1(sc, RE_CFG5) & ~BIT_0);
                 CSR_WRITE_1(sc, RE_CFG2, CSR_READ_1(sc, RE_CFG2) & ~BIT_7);
+                CSR_WRITE_1(sc, 0xF1, CSR_READ_1(sc, 0xF1) & ~ BIT_7);
                 CSR_WRITE_1(sc, RE_CFG2, CSR_READ_1(sc, RE_CFG2) | BIT_5);
-                CSR_WRITE_1(sc, RE_EECMD, RE_EEMODE_OFF);
+                re_disable_cfg9346_write(sc);
                 break;
         }
 
@@ -2542,12 +3379,49 @@ static void re_hw_init(struct re_softc *sc)
         }
 }
 
+static void re_rar_set(struct re_softc *sc, u_int8_t *eaddr)
+{
+        re_enable_cfg9346_write(sc);
+
+        CSR_WRITE_4(sc, RE_IDR0,
+                    htole32(*(u_int32_t *)(&eaddr[0])));
+        CSR_WRITE_2(sc, RE_IDR4,
+                    htole16(*(u_int32_t *)(&eaddr[4])));
+
+        switch (sc->re_type) {
+        case MACFG_36:
+        case MACFG_37:
+        case MACFG_42:
+        case MACFG_43:
+        case MACFG_54:
+        case MACFG_55:
+                CSR_WRITE_4(sc, RE_SecMAC0,
+                            htole32(*(u_int32_t *)(&eaddr[0])));
+                CSR_WRITE_2(sc, RE_SecMAC4,
+                            htole16(*(u_int16_t *)(&eaddr[4])));
+                break;
+        }
+
+        switch (sc->re_type) {
+        case MACFG_38:
+        case MACFG_39:
+                re_eri_write(sc, 0xF0, 4, *(u_int16_t *)(&eaddr[0])<<16, ERIAR_ExGMAC);
+                re_eri_write(sc, 0xF4, 4, *(u_int32_t *)(&eaddr[2]), ERIAR_ExGMAC);
+                break;
+        }
+
+        re_disable_cfg9346_write(sc);
+}
+
 static void re_get_hw_mac_address(struct re_softc *sc, u_int8_t *eaddr)
 {
+        device_t dev = sc->dev;
         u_int16_t re_eeid = 0;
-        u_int8_t read_from_macio = 0;
         int i;
 
+        for (i = 0; i < ETHER_ADDR_LEN; i++)
+                eaddr[i] = CSR_READ_1(sc, RE_IDR0 + i);
+
         switch(sc->re_type) {
         case MACFG_50:
         case MACFG_51:
@@ -2563,58 +3437,42 @@ static void re_get_hw_mac_address(struct re_softc *sc, u_int8_t *eaddr)
         case MACFG_67:
         case MACFG_68:
         case MACFG_69:
-                *(u_int32_t *)&eaddr[0]= re_eri_read(sc, 0xE0, 4, ERIAR_ExGMAC);
+        case MACFG_70:
+        case MACFG_71:
+                *(u_int32_t *)&eaddr[0] = re_eri_read(sc, 0xE0, 4, ERIAR_ExGMAC);
                 *(u_int16_t *)&eaddr[4] = (u_int16_t)re_eri_read(sc, 0xE4, 4, ERIAR_ExGMAC);
                 break;
         case MACFG_63:
         case MACFG_64:
         case MACFG_65:
         case MACFG_66:
-                read_from_macio = 1;
                 break;
         default:
                 re_read_eeprom(sc, (caddr_t)&re_eeid, RE_EE_ID, 1, 0);
                 if (re_eeid == 0x8129)
                         re_read_eeprom(sc, (caddr_t)&eaddr[0], RE_EE_EADDR, 3, 0);
-                else
-                        read_from_macio = 1;
                 break;
         }
 
-        if (eaddr[0] == 0x00 &&
-            eaddr[1] == 0x00 &&
-            eaddr[2] == 0x00 &&
-            eaddr[3] == 0x00 &&
-            eaddr[4] == 0x00 &&
-            eaddr[5] == 0x00) {
-                read_from_macio = 1;
-        }
-
-        if (eaddr[0] == 0xFF &&
-            eaddr[1] == 0xFF &&
-            eaddr[2] == 0xFF &&
-            eaddr[3] == 0xFF &&
-            eaddr[4] == 0xFF &&
-            eaddr[5] == 0xFF) {
-                read_from_macio = 1;
-        }
-
-        if (read_from_macio) {
-                for (i = 0; i < ETHER_ADDR_LEN; i++)
-                        eaddr[i] = CSR_READ_1(sc, RE_IDR0 + i);
+        if (!is_valid_ether_addr(eaddr)) {
+#ifndef __DragonFly__
+                device_printf(dev,"Invalid ether addr: %6D\n", eaddr, ":");
+#else
+		device_printf(dev, "Invalid ether addr: "
+		    "%02x:%02x:%02x:%02x:%02x:%02x\n",
+		    eaddr[0], eaddr[1], eaddr[2], eaddr[3], eaddr[4], eaddr[5]);
+#endif
+                random_ether_addr(eaddr);
+#ifndef __DragonFly__
+                device_printf(dev,"Random ether addr: %6D\n", eaddr, ":");
+#else
+		device_printf(dev, "Random ether addr: "
+		    "%02x:%02x:%02x:%02x:%02x:%02x\n",
+		    eaddr[0], eaddr[1], eaddr[2], eaddr[3], eaddr[4], eaddr[5]);
+#endif
         }
 
-        switch (sc->re_type) {
-        case MACFG_36:
-        case MACFG_37:
-        case MACFG_42:
-        case MACFG_43:
-        case MACFG_54:
-        case MACFG_55:
-                for (i = 0; i < ETHER_ADDR_LEN; i++)
-                        CSR_WRITE_1(sc, RE_SecMAC0 + i, eaddr[i]);
-                break;
-        }
+        re_rar_set(sc, eaddr);
 }
 
 static int re_check_mac_version(struct re_softc *sc)
@@ -2797,13 +3655,13 @@ static int re_check_mac_version(struct re_softc *sc)
         case 0x24000000:
                 sc->re_type = MACFG_41;
                 sc->max_jumbo_frame_size = ETHERMTU;
-                sc->re_if_flags |= RL_FLAG_DESCV2 | RL_FLAG_PHYWAKE_PM ;
+                sc->re_if_flags |= RL_FLAG_DESCV2 | RL_FLAG_PHYWAKE_PM;
                 CSR_WRITE_4(sc, RE_RXCFG, 0xE700);
                 break;
         case 0x40900000:
                 sc->re_type = MACFG_42;
                 sc->max_jumbo_frame_size = ETHERMTU;
-                sc->re_if_flags |= RL_FLAG_DESCV2 | RL_FLAG_PHYWAKE_PM ;
+                sc->re_if_flags |= RL_FLAG_DESCV2 | RL_FLAG_PHYWAKE_PM;
                 CSR_WRITE_4(sc, RE_RXCFG, 0xE700);
                 break;
         case 0x40A00000:
@@ -2811,7 +3669,7 @@ static int re_check_mac_version(struct re_softc *sc)
         case 0x40C00000:
                 sc->re_type = MACFG_43;
                 sc->max_jumbo_frame_size = ETHERMTU;
-                sc->re_if_flags |= RL_FLAG_DESCV2 | RL_FLAG_PHYWAKE_PM ;
+                sc->re_if_flags |= RL_FLAG_DESCV2 | RL_FLAG_PHYWAKE_PM;
                 CSR_WRITE_4(sc, RE_RXCFG, 0xE700);
                 break;
         case 0x48000000:
@@ -2934,6 +3792,18 @@ static int re_check_mac_version(struct re_softc *sc)
                 sc->re_if_flags |= RL_FLAG_DESCV2 | RL_FLAG_PHYWAKE_PM | RL_FLAG_MAGIC_PACKET_V2;
                 CSR_WRITE_4(sc, RE_RXCFG, 0xCF00);
                 break;
+        case 0x54900000:
+                sc->re_type = MACFG_70;
+                sc->max_jumbo_frame_size = Jumbo_Frame_9k;
+                sc->re_if_flags |= RL_FLAG_DESCV2 | RL_FLAG_PHYWAKE_PM | RL_FLAG_MAGIC_PACKET_V2;
+                CSR_WRITE_4(sc, RE_RXCFG, 0xCF00);
+                break;
+        case 0x54A00000:
+                sc->re_type = MACFG_71;
+                sc->max_jumbo_frame_size = Jumbo_Frame_9k;
+                sc->re_if_flags |= RL_FLAG_DESCV2 | RL_FLAG_PHYWAKE_PM | RL_FLAG_MAGIC_PACKET_V2;
+                CSR_WRITE_4(sc, RE_RXCFG, 0xCF00);
+                break;
         default:
                 device_printf(dev,"unknown device\n");
                 sc->re_type = MACFG_FF;
@@ -2974,6 +3844,133 @@ static void re_init_software_variable(struct re_softc *sc)
         }
 
         switch(sc->re_type) {
+        case MACFG_63:
+        case MACFG_64:
+        case MACFG_65:
+        case MACFG_66:
+                sc->HwSuppDashVer = 1;
+                break;
+        case MACFG_61:
+        case MACFG_62:
+        case MACFG_67:
+                sc->HwSuppDashVer = 2;
+                break;
+        case MACFG_70:
+        case MACFG_71:
+                sc->HwSuppDashVer = 3;
+                break;
+        default:
+                sc->HwSuppDashVer = 0;
+                break;
+        }
+
+        switch(sc->re_type) {
+        case MACFG_70:
+        case MACFG_71:
+                sc->HwPkgDet = MP_ReadMcuAccessRegWord(sc, 0xDC00);
+                sc->HwPkgDet = (sc->HwPkgDet >> 3) & 0x0F;
+                //printf("Realtek PCIe GBE Family Controller HwPkgDet = 0x%02X\n",
+                //       sc->HwPkgDet);
+                break;
+        }
+
+        if (HW_DASH_SUPPORT_TYPE_3(sc) && sc->HwPkgDet == 0x06)
+                eee_enable = 0;
+
+        if (HW_DASH_SUPPORT_DASH(sc))
+                sc->re_dash = re_check_dash(sc);
+
+        if (sc->re_dash) {
+                if (HW_DASH_SUPPORT_TYPE_3(sc)) {
+                        u_int64_t CmacMemPhysAddress;
+                        bus_space_handle_t cmac_ioaddr;
+
+                        CmacMemPhysAddress = MP_ReadOtherFunPciEConfigSpace(sc, 0, 0xf018);
+                        if (!(CmacMemPhysAddress & BIT_0)) {
+                                if (CmacMemPhysAddress & BIT_2)
+                                        CmacMemPhysAddress |=  MP_ReadOtherFunPciEConfigSpace(sc, 0, 0xf01c) << 16;
+
+                                CmacMemPhysAddress &=  0xFFFFFFF0;
+                                /* ioremap MMIO region */
+#ifndef __DragonFly__
+                                sc->re_mapped_cmac_tag = X86_BUS_SPACE_MEM;
+#else
+				sc->re_mapped_cmac_tag = X86_64_BUS_SPACE_MEM;
+#endif
+                                if (bus_space_map(sc->re_mapped_cmac_tag, CmacMemPhysAddress, RE_REGS_SIZE, 0,
+                                                  &cmac_ioaddr))
+                                        sc->re_dash = 0;
+                                else
+                                        sc->re_mapped_cmac_handle = cmac_ioaddr;
+                        }
+                }
+        }
+
+        switch(sc->re_type) {
+        case MACFG_61:
+        case MACFG_62:
+        case MACFG_67:
+                sc->re_cmac_handle = sc->re_bhandle;
+                sc->re_cmac_tag = sc->re_btag;
+                break;
+        case MACFG_70:
+        case MACFG_71:
+                sc->re_cmac_handle = sc->re_mapped_cmac_handle;
+                sc->re_cmac_tag = sc->re_mapped_cmac_tag;
+                break;
+        }
+
+        switch(sc->re_type) {
+        case MACFG_14:
+        case MACFG_15:
+        case MACFG_16:
+        case MACFG_17:
+        case MACFG_18:
+        case MACFG_19:
+        case MACFG_31:
+        case MACFG_32:
+        case MACFG_33:
+        case MACFG_41:
+        case MACFG_63:
+        case MACFG_64:
+        case MACFG_65:
+        case MACFG_66:
+                sc->re_efuse_ver = EFUSE_SUPPORT_V1;
+                break;
+        case MACFG_36:
+        case MACFG_37:
+        case MACFG_42:
+        case MACFG_43:
+        case MACFG_54:
+        case MACFG_55:
+                sc->re_efuse_ver = EFUSE_SUPPORT_V2;
+                break;
+        case MACFG_38:
+        case MACFG_39:
+        case MACFG_50:
+        case MACFG_51:
+        case MACFG_52:
+        case MACFG_53:
+        case MACFG_56:
+        case MACFG_57:
+        case MACFG_58:
+        case MACFG_59:
+        case MACFG_60:
+        case MACFG_61:
+        case MACFG_62:
+        case MACFG_67:
+        case MACFG_68:
+        case MACFG_69:
+        case MACFG_70:
+        case MACFG_71:
+                sc->re_efuse_ver = EFUSE_SUPPORT_V3;
+                break;
+        default:
+                sc->re_efuse_ver = EFUSE_NOT_SUPPORT;
+                break;
+        }
+
+        switch(sc->re_type) {
         case MACFG_69: {
                 u_int16_t ioffset_p3, ioffset_p2, ioffset_p1, ioffset_p0;
                 u_int16_t TmpUshort;
@@ -3006,7 +4003,9 @@ static void re_init_software_variable(struct re_softc *sc)
 
         switch(sc->re_type) {
         case MACFG_68:
-        case MACFG_69: {
+        case MACFG_69:
+        case MACFG_70:
+        case MACFG_71: {
                 u_int16_t rg_saw_cnt;
 
                 MP_WritePhyUshort(sc, 0x1F, 0x0C42);
@@ -3054,6 +4053,8 @@ static void re_init_software_variable(struct re_softc *sc)
         case MACFG_67:
         case MACFG_68:
         case MACFG_69:
+        case MACFG_70:
+        case MACFG_71:
                 sc->re_hw_enable_msi_msix = TRUE;
                 break;
         }
@@ -3106,12 +4107,56 @@ static void re_init_software_variable(struct re_softc *sc)
         case MACFG_67:
         case MACFG_68:
         case MACFG_69:
+        case MACFG_70:
+        case MACFG_71:
                 sc->re_hw_supp_now_is_oob_ver = 1;
                 break;
         }
 
-        sc->re_8169_MacVersion=(CSR_READ_4(sc, RE_TXCFG)&0x7c800000)>>25;		/* Get bit 26~30 	*/
-        sc->re_8169_MacVersion|=((CSR_READ_4(sc, RE_TXCFG)&0x00800000)!=0 ? 1:0);	/* Get bit 23 		*/
+        switch (sc->re_type) {
+        case MACFG_36:
+        case MACFG_37:
+                sc->re_sw_ram_code_ver = NIC_RAMCODE_VERSION_8168E;
+                break;
+        case MACFG_38:
+        case MACFG_39:
+                sc->re_sw_ram_code_ver = NIC_RAMCODE_VERSION_8168EVL;
+                break;
+        case MACFG_50:
+        case MACFG_51:
+                sc->re_sw_ram_code_ver = NIC_RAMCODE_VERSION_8168F;
+                break;
+        case MACFG_52:
+                sc->re_sw_ram_code_ver = NIC_RAMCODE_VERSION_8411;
+                break;
+        case MACFG_56:
+        case MACFG_57:
+                sc->re_sw_ram_code_ver = NIC_RAMCODE_VERSION_8168G;
+                break;
+        case MACFG_58:
+        case MACFG_59:
+                sc->re_sw_ram_code_ver = NIC_RAMCODE_VERSION_8168GU;
+                break;
+        case MACFG_60:
+                sc->re_sw_ram_code_ver = NIC_RAMCODE_VERSION_8411B;
+                break;
+        case MACFG_61:
+        case MACFG_62:
+        case MACFG_67:
+                sc->re_sw_ram_code_ver = NIC_RAMCODE_VERSION_8168EP;
+                break;
+        case MACFG_68:
+        case MACFG_69:
+                sc->re_sw_ram_code_ver = NIC_RAMCODE_VERSION_8168H;
+                break;
+        case MACFG_70:
+        case MACFG_71:
+                sc->re_sw_ram_code_ver = NIC_RAMCODE_VERSION_8168FP;
+                break;
+        }
+
+        sc->re_8169_MacVersion=(CSR_READ_4(sc, RE_TXCFG)&0x7c800000)>>25;		/* Get bit 26~30 	*/
+        sc->re_8169_MacVersion|=((CSR_READ_4(sc, RE_TXCFG)&0x00800000)!=0 ? 1:0);	/* Get bit 23 		*/
         DBGPRINT1(sc->re_unit,"8169 Mac Version %d",sc->re_8169_MacVersion);
 
         /* Rtl8169s single chip detected */
@@ -3131,7 +4176,8 @@ static void re_hw_d3_para(struct re_softc *sc)
 {
         if (sc->re_type == MACFG_59 || sc->re_type == MACFG_60 ||
             sc->re_type == MACFG_62 || sc->re_type == MACFG_67 ||
-            sc->re_type == MACFG_68 || sc->re_type == MACFG_69) {
+            sc->re_type == MACFG_68 || sc->re_type == MACFG_69 ||
+            sc->re_type == MACFG_70 || sc->re_type == MACFG_71) {
                 MP_WritePhyOcpRegWord(sc, 0x0C41, 0x13, 0x0000);
                 MP_WritePhyOcpRegWord(sc, 0x0C41, 0x13, 0x0500);
         }
@@ -3346,12 +4392,14 @@ static int re_attach(device_t dev)
         RE_UNLOCK(sc);
 
         /* Get station address. */
+        RE_LOCK(sc);
         re_get_hw_mac_address(sc, eaddr);
+        RE_UNLOCK(sc);
 
         /*
          * A RealTek chip was detected. Inform the world.
          */
-        device_printf(dev,"version:1.93\n");
+        device_printf(dev,"version:1.94.01\n");
         device_printf(dev,"Ethernet address: %6D\n", eaddr, ":");
         printf("\nThis product is covered by one or more of the following patents: \
            \nUS6,570,884, US6,115,776, and US6,327,625.\n");
@@ -3643,6 +4691,9 @@ static int re_detach(device_t dev)
         if (sc->re_res)
                 bus_release_resource(dev, sc->re_res_type, sc->re_res_id, sc->re_res);
 
+        if (HW_DASH_SUPPORT_TYPE_3(sc) && sc->re_dash)
+                bus_space_unmap(sc->re_cmac_tag, sc->re_mapped_cmac_handle, RE_REGS_SIZE);
+
         if (sc->re_desc.re_rx_mtag) {
                 for (i = 0; i < RE_RX_BUF_NUM; i++) {
                         if (sc->re_desc.rx_buf[i]!=NULL) {
@@ -3850,17 +4901,8 @@ device_t		dev;
 
         sc = device_get_softc(dev);
 
-        switch(sc->re_type) {
-        case MACFG_61:
-        case MACFG_62:
-        case MACFG_67:
-        case MACFG_63:
-        case MACFG_64:
-        case MACFG_65:
-        case MACFG_66:
+        if (sc->re_dash)
                 re_driver_stop(sc);
-                break;
-        }
 
         RE_LOCK(sc);
         sc->re_link_chg_det = 0;
@@ -3891,7 +4933,38 @@ static void re_hw_start_unlock(struct re_softc *sc)
         re_var_init(sc);
 #endif
 
-        CSR_WRITE_1(sc, RE_EECMD, RE_EEMODE_WRITECFG);
+        re_enable_cfg9346_write(sc);
+
+        switch(sc->re_type) {
+        case MACFG_36:
+        case MACFG_37:
+        case MACFG_38:
+        case MACFG_39:
+        case MACFG_42:
+        case MACFG_43:
+        case MACFG_50:
+        case MACFG_51:
+        case MACFG_52:
+        case MACFG_53:
+        case MACFG_54:
+        case MACFG_55:
+        case MACFG_56:
+        case MACFG_57:
+        case MACFG_58:
+        case MACFG_59:
+        case MACFG_60:
+        case MACFG_61:
+        case MACFG_62:
+        case MACFG_67:
+        case MACFG_68:
+        case MACFG_69:
+        case MACFG_70:
+        case MACFG_71:
+                CSR_WRITE_1(sc, RE_CFG5, CSR_READ_1(sc, RE_CFG5) & ~BIT_0);
+                CSR_WRITE_1(sc, RE_CFG2, CSR_READ_1(sc, RE_CFG2) & ~BIT_7);
+                CSR_WRITE_1(sc, 0xF1, CSR_READ_1(sc, 0xF1) & ~ BIT_7);
+                break;
+        }
 
         /*disable Link Down Power Saving(non-LDPS)*/
         /*CSR_WRITE_1(sc, RE_LDPS, 0x05);*/
@@ -4001,6 +5074,9 @@ static void re_hw_start_unlock(struct re_softc *sc)
                         MP_WriteEPhyUshort(sc, 0x06, 0xAF35);
                 }
         } else if (macver == 0x3C000000) {
+                //disable clock request.
+                pci_write_config(sc->dev, 0x81, 0, 1);
+
                 /*set configuration space offset 0x70f to 0x27*/
                 Data32 = MP_ReadPciEConfigSpace(sc, 0x870c);
                 Data32 &=0xC0FFFFFF;
@@ -4025,9 +5101,6 @@ static void re_hw_start_unlock(struct re_softc *sc)
                         data16 = MP_ReadEPhyUshort(sc, 0x06) & ~0x0080;
                         MP_WriteEPhyUshort(sc, 0x06, data16);
 
-                        //disable clock request.
-                        pci_write_config(sc->dev, 0x81, 0, 1);
-
                         if (ifp->if_mtu > ETHERMTU) {
                                 CSR_WRITE_1(sc, RE_CFG3, CSR_READ_1(sc, RE_CFG3) | BIT_2); //Jumbo_en0
                                 CSR_WRITE_1(sc, RE_CFG4, CSR_READ_1(sc, RE_CFG4) | (1 << 1)); //Jumbo_en1
@@ -4059,8 +5132,6 @@ static void re_hw_start_unlock(struct re_softc *sc)
                                         CSR_WRITE_2 (sc, RE_CPlusCmd,CSR_READ_2(sc, RE_CPlusCmd) |RL_RxChkSum);
                                 }
                         }
-
-
                 } else if (sc->re_type == MACFG_25) {
                         data16 = MP_ReadEPhyUshort(sc, 0x01) | 0x0001;
                         MP_WriteEPhyUshort(sc, 0x01, data16);
@@ -4069,9 +5140,6 @@ static void re_hw_start_unlock(struct re_softc *sc)
                         data16 |= 0x0220;
                         MP_WriteEPhyUshort(sc, 0x03, data16);
 
-                        //disable clock request.
-                        pci_write_config(sc->dev, 0x81, 0, 1);
-
                         if (ifp->if_mtu > ETHERMTU) {
                                 CSR_WRITE_1(sc, RE_CFG3, CSR_READ_1(sc, RE_CFG3) | BIT_2); //Jumbo_en0
                                 CSR_WRITE_1(sc, RE_CFG4, CSR_READ_1(sc, RE_CFG4) | (1<<1)); //Jumbo_en1
@@ -4105,11 +5173,7 @@ static void re_hw_start_unlock(struct re_softc *sc)
 
 
                         }
-
                 } else if (sc->re_type == MACFG_26) {
-                        //disable clock request.
-                        pci_write_config(sc->dev, 0x81, 0, 1);
-
                         if (ifp->if_mtu > ETHERMTU) {
                                 CSR_WRITE_1(sc, RE_CFG3, CSR_READ_1(sc, RE_CFG3) | BIT_2); //Jumbo_en0
                                 CSR_WRITE_1(sc, RE_CFG4, CSR_READ_1(sc, RE_CFG4) | (1<<1)); //Jumbo_en1
@@ -4142,6 +5206,9 @@ static void re_hw_start_unlock(struct re_softc *sc)
                         }
                 }
         } else if (macver == 0x3C800000) {
+                //disable clock request.
+                pci_write_config(sc->dev, 0x81, 0x00, 1);
+
                 /*set configuration space offset 0x70f to 0x27*/
                 Data32 = MP_ReadPciEConfigSpace(sc, 0x870c);
                 Data32 &=0xC0FFFFFF;
@@ -4150,9 +5217,6 @@ static void re_hw_start_unlock(struct re_softc *sc)
 
                 re_eri_write(sc, 0x1EC, 1, 0x07, ERIAR_ASF);
 
-                //disable clock request.
-                pci_write_config(sc->dev, 0x81, 0x00, 1);
-
                 CSR_WRITE_1(sc, RE_CFG3, CSR_READ_1(sc, RE_CFG3) & ~BIT_0);
                 CSR_WRITE_2 (sc, RE_CPlusCmd, 0x2060);
                 if (sc->re_type == MACFG_28)
@@ -4185,17 +5249,17 @@ static void re_hw_start_unlock(struct re_softc *sc)
                                 CSR_WRITE_2 (sc, RE_CPlusCmd,CSR_READ_2(sc, RE_CPlusCmd) |RL_RxChkSum);
                         }
                 }
-
-
         } else if (macver == 0x28000000) {
+                //disable clock request.
+                pci_write_config(sc->dev, 0x81, 0x00, 1);
+
                 /*set configuration space offset 0x70f to 0x13*/
                 Data32 = MP_ReadPciEConfigSpace(sc, 0x870c);
                 Data32 &=0xC0FFFFFF;
-                Data32 |= (0x13 << 24);
+                Data32 |= (0x27 << 24);
                 MP_WritePciEConfigSpace(sc, 0x870c, Data32);
 
-                /* disable clock request. */
-                pci_write_config(sc->dev, 0x81, 0x00, 1);
+                CSR_WRITE_1(sc, RE_TDFNR, 0x8);
 
                 CSR_WRITE_1(sc, 0xD1, CSR_READ_1(sc, 0xD1) | 0x02);
 
@@ -4263,14 +5327,19 @@ static void re_hw_start_unlock(struct re_softc *sc)
                         MP_WriteEPhyUshort(sc, 0x0A, 0x8100);
                 }
         } else if (macver == 0x28800000) {
+                /* disable clock request. */
+                pci_write_config(sc->dev, 0x81, 0x00, 1);
+
                 /*set configuration space offset 0x70f to 0x17*/
                 Data32 = MP_ReadPciEConfigSpace(sc, 0x870c);
                 Data32 &=0xC0FFFFFF;
-                Data32 |= (0x17 << 24);
+                Data32 |= (0x27 << 24);
                 MP_WritePciEConfigSpace(sc, 0x870c, Data32);
 
-                /* disable clock request. */
-                pci_write_config(sc->dev, 0x81, 0x00, 1);
+                CSR_WRITE_1(sc, RE_TDFNR, 0x8);
+                if (sc->re_dash &&
+                    (sc->re_type == MACFG_63 || sc->re_type == MACFG_64))
+                        CSR_WRITE_1(sc, RE_TDFNR, 0x1);
 
                 CSR_WRITE_1(sc, RE_CFG3, CSR_READ_1(sc, RE_CFG3) & ~BIT_0);
                 CSR_WRITE_1(sc, RE_DBG_reg, CSR_READ_1(sc, RE_DBG_reg)|0x82);
@@ -4324,21 +5393,25 @@ static void re_hw_start_unlock(struct re_softc *sc)
                         ClearPCIePhyBit(sc, 0x10, (BIT_2));
                 }
         } else if (macver == 0x2C000000) {
+                /* disable clock request. */
+                pci_write_config(sc->dev, 0x81, 0x00, 1);
+
                 /*set configuration space offset 0x70f to 0x20*/
                 Data32 = MP_ReadPciEConfigSpace(sc, 0x870c);
                 Data32 &=0xC0FFFFFF;
-                Data32 |= (0x20 << 24);
+                Data32 |= (0x27 << 24);
                 MP_WritePciEConfigSpace(sc, 0x870c, Data32);
 
                 CSR_WRITE_1(sc, 0xF3, CSR_READ_1(sc, 0xF3)|0x20);
                 CSR_WRITE_1(sc, 0xF3, CSR_READ_1(sc, 0xF3)& ~0x20);
 
                 CSR_WRITE_1(sc, 0xD0, CSR_READ_1(sc, 0xD0)|0xC0);
-                CSR_WRITE_1(sc, 0xF1, CSR_READ_1(sc, 0xF1)|0xF3);
-                CSR_WRITE_1(sc, RE_CFG5, (CSR_READ_1(sc, RE_CFG5)& ~0x08)|0x01);
-                CSR_WRITE_1(sc, RE_CFG2, CSR_READ_1(sc, RE_CFG2)|0x80);
+                CSR_WRITE_1(sc, 0xF1, CSR_READ_1(sc, 0xF1)|0x73);
+                CSR_WRITE_1(sc, RE_CFG5, (CSR_READ_1(sc, RE_CFG5)& ~0x08));
                 CSR_WRITE_1(sc, RE_CFG3, CSR_READ_1(sc, RE_CFG3) & ~BIT_0);
 
+                CSR_WRITE_1(sc, RE_TDFNR, 0x8);
+
                 if (sc->re_type == MACFG_36 || sc->re_type == MACFG_37) {
                         /* set EPHY registers */
                         data16 = MP_ReadEPhyUshort(sc, 0x00) & ~0x0200;
@@ -4420,11 +5493,11 @@ static void re_hw_start_unlock(struct re_softc *sc)
                                         CSR_WRITE_2 (sc, RE_CPlusCmd,CSR_READ_2(sc, RE_CPlusCmd) |RL_RxChkSum);
                                 }
                         }
-
-                        //disable clock request.
-                        pci_write_config(sc->dev, 0x81, 1, 1);
                 }
         } else if (macver == 0x2C800000) {
+                /* disable clock request. */
+                pci_write_config(sc->dev, 0x81, 0x00, 1);
+
                 /*set configuration space offset 0x70f to 0x27*/
                 Data32 = MP_ReadPciEConfigSpace(sc, 0x870c);
                 Data32 &=0xC0FFFFFF;
@@ -4436,14 +5509,7 @@ static void re_hw_start_unlock(struct re_softc *sc)
                 data8 |= 0x50;
                 pci_write_config(sc->dev, 0x79, data8, 1);
 
-                Data32 = CSR_READ_2(sc, RE_IDR0);
-                Data32 <<= 16;
-                Data32 &= 0xFFFF0000;
-                re_eri_write(sc, 0xF0, 4, Data32, ERIAR_ExGMAC);
-                Data32 = CSR_READ_2(sc, RE_IDR4);
-                Data32 <<= 16;
-                Data32 += CSR_READ_2(sc, RE_IDR2);
-                re_eri_write(sc, 0xF4, 4, Data32, ERIAR_ExGMAC);
+                CSR_WRITE_1(sc, RE_TDFNR, 0x8);
 
                 re_eri_write(sc, 0xC0, 2, 0x0000, ERIAR_ExGMAC);
                 re_eri_write(sc, 0xB8, 4, 0x00000000, ERIAR_ExGMAC);
@@ -4469,7 +5535,6 @@ static void re_hw_start_unlock(struct re_softc *sc)
                 CSR_WRITE_4(sc, RE_TXCFG, CSR_READ_4(sc, RE_TXCFG) |BIT_7);
                 CSR_WRITE_1(sc, 0xD3, CSR_READ_1(sc, 0xD3) & ~BIT_7);
                 CSR_WRITE_1(sc, 0x1B, CSR_READ_1(sc, 0x1B) & ~0x07);
-                CSR_WRITE_1(sc, 0xF1,CSR_READ_1(sc, 0xF1) & ~ BIT_7);
 
                 CSR_WRITE_2 (sc, RE_CPlusCmd, 0x2060);
 
